# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, playerlib, keyvalues, os, random
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func   = es.import_addon('sam/functions')
core   = es.import_addon('sam/core')
admins = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
db     = 'sam_groups'
dbpath = func.dbPath + 'es_%s_db.txt' % db
imm    = {}
temp   = {'toggle':False,'addFilter':[]}
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# DATABASE
	if existsDB(): es.keygroupload(db, func.dbfolder)

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# DATABASE
	es.keygroupdelete(db)

	# DELETE FILTERS
	try: es.addons.unregisterSayFilter(immGroupFilter)
	except: pass
	try: es.addons.unregisterSayFilter(addGroupFilter)
	except: pass

	# POPUPS
	func.popupDelete('listpPage')
	func.popupDelete('editGroup')
	func.popupDelete('chooseColor')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def pageChoice(ID, choice):
	if choice == 4:
		temp['addFilter'].append(ID)
		func.cloud['filters'].append(ID)
		es.addons.registerSayFilter(addGroupFilter)
		func.hudhint(ID, '%s\n%s' % (func.langAdmins('TOADD_GROUP'),func.langCore('TO_CANCEL_OP')), func.adminstag)
	else:
		if not len(listGroups()) == 0:
			OPTIONS = {5:'GROUP_REMOVE',6:'GROUP_EDIT'}
			func.popupDelete('listPage')
			if   choice == 5: popup = func.easymenu(popuplib.easymenu('listPage', None, remove),'adminspage')
			elif choice == 6: popup = func.easymenu(popuplib.easymenu('listPage', None, edit),'adminspage')
			popup.settitle(func.header(func.langAdmins('%s_OPTION' % OPTIONS[choice])))
			popup.setdescription(' # %s ' % func.langCommon('CHOOSE_GROUP'))
			for x in listGroups():
				update(x)
				popup.addoption(x, x)
			popup.send(ID)
		else:
			func.hudhint(ID, func.langAdmins('NO_GROUPS'), func.adminstag)
			admins.page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def add(ID, name):
	if not isGroup(name):
		if not es.exists('keygroup', db): es.keygroupcreate(db)
		es.keycreate(db, name)
		setkey(name, 'color', random.choice([x for x in func.colors]))
		setkey(name, 'immunity', 0)
		setkey(name, 'Ban Level', 2)
		for x in admins.access: setkey(name, x, 'yes')
		func.hudhint(ID, func.langAdmins('GROUP_ADDED', {'group':name}), func.adminstag)
	else: func.hudhint(ID, func.langAdmins('IS_GROUP'), func.adminstag)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def remove(ID, target, popup):
	es.keydelete(db, target)
	es.keygroupsave(db, func.dbfolder)
	func.hudhint(ID, func.langAdmins('GROUP_REMOVED', {'group':target}), func.adminstag)
	for admin in admins.listAdmins():
		if admins.getkey(admin,'group') == target: admins.setkey(admin,'group','NO_GROUP')
	admins.page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def edit(ID, group, popup, page=False):
	func.popupDelete('editGroup')
	popup = func.easymenu(popuplib.easymenu('editGroup', None, editSelect),'adminspage')
	popup.c_beginsep = '%s\n# %s: %s\n%s' % (func.line,func.langCommon('NAME').upper(),group,func.line)
	popup.settitle(func.header(func.langAdmins('EDIT_OPTION')))
	popup.addoption(['addAdmins',group], func.langAdmins('SELECT_ADMINS'))
	popup.addoption(['toggle',group], func.langAdmins('TOGGLE_OPTION'))
	popup.addoption(['imm',group], '%s: %s' % (func.langCommon('IMMUNITY'),getkey(group,'immunity')))
	popup.addoption(['color',group], '%s: %s' % (func.langCommon('COLOR'),getkey(group,'color').replace('#','').upper()))
	popup.addoption(['ban',group], 'Ban Level: %s' % getkey(group,'Ban Level'))
	for x in admins.access:
		if getkey(group,x) == 'yes': popup.addoption([x,group], '%s: %s' % (x,func.langCommon('YES')))
		else: popup.addoption([x,group], '%s: %s' % (x,func.langCommon('NO')))
	if not page: popup.send(ID)
	else: popup.sendPage(ID, page)

# ------------------------------------------------------------------------------- #
def editSelect(ID, token, popup, page=False):
	if token[0] == 'addAdmins':
		func.popupDelete('addadmins')
		popup = func.easymenu(popuplib.easymenu('addadmins', None, adminsToGroup),'editGroup')
		popup.settitle(func.header(func.langAdmins('EDIT_OPTION')))
		popup.setdescription(' # %s ' % func.langAdmins('SELECT_ADMINS'))
		for admin in admins.listAdmins():
			if admins.getkey(admin,'group') == token[1]: popup.addoption([admin,token[1]], '%s [ X ]' % (admins.getkey(admin,'name')))
			else: popup.addoption([admin,token[1]], '%s [ . ]' % (admins.getkey(admin,'name')))
		if not page: popup.send(ID)
		else: popup.sendPage(ID, page)
	elif token[0] == 'toggle': toggle(token[1])
	elif token[0] == 'imm':
		if not ID in imm: imm[ID] = token[1]
		func.cloud['filters'].append(ID)
		es.addons.registerSayFilter(immGroupFilter)
		func.hudhint(ID, '%s\n%s' % (func.langAdmins('TOSET_IMMUNITY'),func.langCore('TO_CANCEL_OP')), func.adminstag)
	elif token[0] == 'color':
		func.popupDelete('chooseColor')
		popup = func.easymenu(popuplib.easymenu('chooseColor', None, chooseColor),'editGroup')
		popup.settitle(func.header(func.langAdmins('EDIT_OPTION')))
		for x in func.colors: popup.addoption([x,token[1]], x.strip('#').upper())
		popup.send(ID)
	elif token[0] == 'ban':
		level = int(getkey(token[1],'Ban Level')) + 1
		if level < 3: setkey(token[1],'Ban Level',level)
		else: setkey(token[1],'Ban Level',0)
	else:
		if getkey(token[1],token[0]) == 'yes': setkey(token[1],token[0],'no')
		else: setkey(token[1],token[0],'yes')
		edit(ID, token[1], None, func.sendPage(admins.access.index(token[0])+5))
	if token[0] in ('toggle','ban'): edit(ID, token[1], None)

# ------------------------------------------------------------------------------- #
def adminsToGroup(ID, target, popup):
	if admins.getkey(target[0],'group') == target[1]: admins.setkey(target[0],'group','NO_GROUP')
	else: admins.setkey(target[0],'group',target[1])
	editSelect(ID, ['addAdmins',target[1]], None, func.sendPage(admins.listAdmins().index(target[0])))

# ------------------------------------------------------------------------------- #
def chooseColor(ID, token, popup):
	setkey(token[1],'color',token[0])
	edit(ID, token[1], None)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def existsDB():
	if os.path.isfile(dbpath): return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def getkey(GROUP, KEY):
	if not GROUP == 'NO_GROUP': return es.keygetvalue(db, GROUP, KEY)
	elif KEY == 'immunity': return 0
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def setkey(GROUP, KEY, VALUE):
	es.keysetvalue(db, GROUP, KEY, VALUE)
	es.keygroupsave(db, func.dbfolder)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def isGroup(target):
	if target in listGroups(): return True
	else: return False

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def listGroups():
	if existsDB(): return [str(x) for x in keyvalues.getKeyGroup(db)]
	else: return []

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def toggle(group):
	for item in admins.access: setkey(group,item,temp['toggle'])
	if temp['toggle'] == 'yes':
		setkey(group,'Ban Level',2)
		temp['toggle'] = 'no'
	else:
		setkey(group,'Ban Level',0)
		temp['toggle'] = 'yes'

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def update(GROUP):
	for x in admins.access:
		if not es.exists('keyvalue',db,GROUP,x): setkey(GROUP, x, 'no')

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def immGroupFilter(ID, text, teamonly):
	if ID in imm:
		text = text.strip('"')
		if str(text) == '!cancel': func.hudhint(ID, func.langCore('OP_CANCEL'), func.cloud['tag'])
		elif text.isdigit() and int(text) in range(101):
			setkey(imm[ID], 'immunity', text)
			func.hudhint(ID, func.langAdmins('SET_GROUP_IMM',{'group':imm[ID],'imm':text}), func.adminstag)
		else: func.hudhint(ID, func.langAdmins('IMM_NOTIN_RANGE'),func.adminstag)
		es.addons.unregisterSayFilter(immGroupFilter)
		edit(ID, imm[ID], None)
		del imm[ID]
		func.cloud['filters'].remove(ID)
		return (0, 0, 0)
	else: return (ID, text, teamonly)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def addGroupFilter(ID, text, teamonly):
	if ID in temp['addFilter']:
		text = str(text.strip('"'))
		if text == '!cancel':
			func.hudhint(ID, func.langCore('OP_CANCEL'), func.cloud['tag'])
			admins.page(ID)
		else:
			add(ID, text)
			edit(ID, text, None)
		es.addons.unregisterSayFilter(addGroupFilter)
		temp['addFilter'].remove(ID)
		func.cloud['filters'].remove(ID)
		return (0, 0, 0)
	else: return (ID, text, teamonly)

# =============================================================================== #