# =============================================================================== #
# xxx <>>> ES/PYTHON IMPORTS xxxxxxxxxx #
import es, popuplib, playerlib, time
import psyco
psyco.full()
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# xxxxxxxxxx # SAM IMPORTS # xxxxxxxxxx #
func     = es.import_addon('sam/functions')
core     = es.import_addon('sam/core')
pcontrol = es.import_addon('sam/core/pcontrol')
admins   = es.import_addon('sam/core/admins')
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# x # VARIABLES/DICTIONARIES/LISTS # xx #
dbname  = 'sam_mutes.db'
data    = func.getDB(dbname)
tag     = '#greenMUTE'
times   = {0:'PERM',300:'5M',1800:'30M',3600:'1H',10800:'3H',86400:'1D',259200:'3D',604800:'1W',2592000:'1MO',31536000:'1Y'}
muted   = []
getsecs = lambda hms:sum(map(lambda a,b: int(a)*b,hms.split(':'),(3600,60,1)))
# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #

# =============================================================================== #
# === <<<> LOAD <>>> ============================================================ #
# =============================================================================== #
def load():

	# FILTERS
	es.addons.registerSayFilter(ChatMuteFilter)
	es.addons.registerTickListener(MuteFilter)

	# LIST MUTED
	for x in data:
		user = es.getuserid(x)
		if es.exists('userid', user):
			if not user in muted: muted.append(user)

	# CMDS
	func.SayCMD('!mute', muteCMD)
	func.SayCMD('!sam_mute', muteCMD)
	func.SayCMD('!unmute', unmuteCMD)
	func.SayCMD('!sam_unmute', unmuteCMD)

	# POPUPS
	func.popupDelete('mutePlist')
	func.popupDelete('muteTime')

# =============================================================================== #
# === <<<> UNLOAD <>>> ========================================================== #
# =============================================================================== #
def unload():

	# FILTERS
	es.addons.unregisterSayFilter(ChatMuteFilter)
	es.addons.unregisterTickListener(MuteFilter)

	# SAVE DATABASE
	func.saveDB(dbname, data)

	# CMDS
	func.unSayCMD('!mute')
	func.unSayCMD('!sam_mute')
	func.unSayCMD('!unmute')
	func.unSayCMD('!sam_unmute')

	# POPUPS
	func.popupDelete('mutePlist')
	func.popupDelete('muteTime')

# =============================================================================== #
# === <<<> MAIN BLOCKS <>>> ===================================================== #
# =============================================================================== #
def page(ID, SEND=True):
	func.popupDelete('mutePlist')
	popup = func.easymenu(popuplib.easymenu('mutePlist', None, listChoice),'pcontrol')
	popup.settitle(func.header(func.langPcontrol('MUTE')))
	for x in playerlib.getPlayerList('#human'):
		if isMuted(x.steamid):
			a = int(data[x.steamid]['length'])
			if a in times: popup.addoption(x, '%s [%s]' % (x.name,func.langPcontrol(times[a])))
			else: popup.addoption(x, '%s [%s %s]' % (x.name,a,func.langCommon('MINUTES')))
		else: popup.addoption(x, x.name)
	if SEND: popup.send(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def listChoice(ID, TARGET, POPUP=None, SEND=True):
	if admins.immunity(playerlib.getPlayer(ID),TARGET):
		if not isMuted(TARGET.steamid):
			func.popupDelete('muteTime')
			popup = func.easymenu(popuplib.easymenu('muteTime', None, mute),'mutePlist')
			popup.settitle(func.header(func.langPcontrol('MUTE')))
			a = [x for x in times]
			a.sort()
			for x in a: popup.addoption([TARGET,x], func.langPcontrol(times[x]))
			popup.send(ID)
		else:
			del data[TARGET.steamid]
			if TARGET in muted: muted.remove(es.getuserid(TARGET))
			func.tell('#all', func.langPcontrol('TARGET_UNMUTED',{'target':TARGET.name}), tag)
			page(ID)
	else: page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def mute(ID, ARGS, POPUP=None, SEND=True):
	target = ARGS[0]
	secs   = ARGS[1]
	TEMP = {'name':target.name,'length':int(secs/60)}
	if secs == 0: TEMP['muteid'] = 0
	else:         TEMP['muteid'] = secs + int(time.time())
	if not target in muted: muted.append(int(target))
	data[target.steamid] = TEMP
	if not secs in times: func.tell('#all', func.langPcontrol('TARGET_MUTED',{'target':target.name,'length':'%s %s' % (secs/60,func.langCommon('MINUTES'))}), tag)
	else: func.tell('#all', func.langPcontrol('TARGET_MUTED',{'target':target.name,'length':func.langPcontrol(times[secs])}), tag)
	if SEND: page(ID)

# =============================================================================== #
# === <<<> FUNCTIONS <>>> ======================================================= #
# =============================================================================== #
def isMuted(TARGET, R=False):
	if TARGET in data:
		if data[TARGET]['muteid'] == 0: R = True
		elif int(data[TARGET]['muteid']) > int(time.time()): R = True
		else:
			del data[TARGET]
			if es.exists('userid', es.getuserid(TARGET)): muted.remove(es.getuserid(TARGET))
	return R

# =============================================================================== #
# === <<<> CMD BLOCKS <>>> ====================================================== #
# =============================================================================== #
def muteCMD(ID, ARGS):
	if admins.can(ID,'Mute'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				target = playerlib.getPlayer(target)
				if len(ARGS) == 2:
					if str(ARGS[1]).isdigit(): mute(ID, [target,int(getsecs('0:%s:0' % (ARGS[1])))], None, False)
					else: listChoice(ID, target)
				elif len(ARGS) == 1: listChoice(ID, target)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}))
		else:
			core.home(ID, False)
			pcontrol.page(ID, False)
			page(ID)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def unmuteCMD(ID, ARGS):
	if admins.can(ID,'Mute'):
		if ARGS:
			target = es.getuserid(ARGS[0])
			if es.exists('userid',target):
				admin  = playerlib.getPlayer(ID)
				target = playerlib.getPlayer(target)
				if isMuted(target.steamid) and admins.immunity(admin ,target):
					del data[target.steamid]
					if target in muted: muted.remove(target)
					func.tell('#all', func.langPcontrol('TARGET_UNMUTED',{'target':target.name}), tag)
			else: func.hudhint(ID, func.langPcontrol('TARGET_NOT_EXISTS',{'target':ARGS[0]}))
		else:
			core.home(ID, False)
			pcontrol.page(ID, False)
			page(ID)

# =============================================================================== #
# === <<<> EVENTS <>>> ========================================================== #
# =============================================================================== #
def player_activate(EV):
	if isMuted(EV['es_steamid']): muted.append(EV['userid'])

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def player_disconnect(EV):
	if EV['userid'] in muted: muted.remove(EV['userid'])

# =============================================================================== #
# === <<<> FILTERS AND OTHERS <>>> ============================================== #
# =============================================================================== #
def ChatMuteFilter(ID, TEXT, TEAM):
	if isMuted(es.getplayersteamid(ID)): return(0,0,0)
	else: return(ID,TEXT,TEAM)

# xxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxxx #
def MuteFilter():
	for x in es.getUseridList():
		for target in muted:
			if isMuted(es.getplayersteamid(target)): es.voicechat('nolisten', x, target)

# =============================================================================== #